Welcome

Supplemented by DaVinci Developer, you can use the DaVinci Configurator to create a consistent and optimized ECU configuration. Openness, scalability and easy operation make this tool very practical, and they simplify the development process.

To exploit the optimization potential of the AUTOSAR base software, an ECU-specific ECU Configuration Description is created, which contains the detailed configuration.

The DaVinci Configurator is a fundamental element to:

  • Speed up configuration of the MICROSAR software components
  • Transfer all configurable elements of the software components to a user-friendly user-interface
  • Support the professional user to configure all software components safely
  • Provide a mature, rule-based validation method for the configuration data
  • Check validity of individual parameter values
  • Check consistency of the entire project
  • Include third party AUTOSAR or non-AUTOSAR software components
  • Support of XML file formats for AUTOSAR standard versions from 2 to 4
  • Provide a set of features for well-known use-cases

Beside its use as an optimized user interface, DaVinci Configuratoris also a GCE (Generic Configuration Editor) for AUTOSAR software components. In this operating mode, the user can visualize and edit any ECU configuration files on the fly.

| Overview | www.microsar.com | www.autosar.org |

Version 4.12.1204
© Vector Informatik GmbH


User Manual

User Manual

The DaVinci Configurator manages available software components in a well-formed framework user-interface.

(click into image for more information)

1: Main Menu + Tool Bar: For detailed information about all Main Menu option see Main Menu. For detailed information about the Toolbar see Toolbar.

2: Navigation: For detailed information see Navigation.

3: Architecture panel: For detailed information see Architecture.

4: Messages: For detailed information see Messages.


Introduction

User Manual » Introduction

This introduction briefly describes:

  • First Steps

This section is intended to serve as a general introduction to DaVinci Configurator.

| www.microsar.com | www.autosar.org |


First Steps

User Manual » Introduction » First Steps

Creating a new project

The first step after starting the DaVinci Configurator is to create a new project.

This can be done via 'File->New' or 'File->Project Assistant->New ECUC Project' in the main menu.

With 'File->New from existing project' it is also possible to create a new project using an already existing one as template:

After creation a project should be saved with 'File->Save'. A project filename and a folder have to be specified.

Info

Info

Each project should be saved in a separate folder.

Setting general options

Via 'Project ->Options' the general options can be reached. In the register 'General' the project author, company, project description and revision can be entered. After the project was saved at least once, the file logging options can be activated here, too.

Modifying architecture view

Via 'Project->Architecture' the architecture of the project is opened. An overview of the modules is shown as well as the used controller and compiler version.

After choosing a controller (and according compiler) the different modules can be activated or deactivated with right-clicking and selecting the desired option in the context menu.

Configuring modules

The modules that have been set to 'active' in 'Project->Architecture' can be chosen for configuration in the project navigation. After selection the data pane shows all parameters connected with the module and allows changing them.

Generating reports

For each module and module-group a summary of the configuration can be created, a so-called report. The reports are available via 'Tools->Report' in the main menu. Before generating a report, the project has to be saved.

Validating the project configuration

The configuration for all active modules can be checked for consistency with the project 'Validation'. The DaVinci Configurator checks the values of the modules for validity, cross-references etc., provides information about the kind of error (in case of an invalid configuration) and gives hints about the needed change(s) (if possible).

Generating the output of the project

If the configuration of a project can be validated without error messages, the project can be generated. In 'Project ->Options' the register 'Target Folders' can be used to specify the directories the output is saved in. It is possible to enter an own directory for each module, to enter a target root folder with sub-directories for the modules or to use a combination of both.

If the 'Generation' is triggered, an additional 'Validation' will be made and after successfully passing this step, the DaVinci Configurator applies the values entered for the project to the templates and saves the resulting configuration files in the 'Target Folders'.

| Configurator | License |


User Settings

User Manual » Introduction » First Steps » User Settings

Description

There are essentially two files which hold additional user made settings.

.Profile

The file '.Profile' will be created on the first modification of a user setting and is located in the ./__Engine folder of the selected Package License.

The file stores all user settings which are not specific to any project to enhance tool usability:

  • DaVinci Configurator window size and position
  • Last selections (folder, Package License, ...)
  • Recent file list
  • Default AUTOSAR ECUC revision number on creating a new project
  • Modified project defaults (author, version, company, ...), that will be used on creating a new project
  • Input format for named integer parameters

Most .profile settings are done in Tools/Preferences dialog, some are changed automatically.

Info

Info

Delete the file .Profile to get all initial user settings back.

.System

The file '.System' will be created on the first modification of a system setting and is located in the ./__Engine folder of the selected Package License.

The file stores changes of the default system settings as defined in the delivered Tool.System:

  • Generic information as e.g. location of the root folder for all manuals or help files
  • Module properties as e.g. customized validation or generation settings
  • Included 3rd party modules with related settings
  • Module related user added file references (MyLinks)

Most .System settings are done in Tools/Preferences dialog, some are changed automatically.

Info

Info

Delete the file .System to get all initial system settings back.

The .System affects the configuration of the ECUC project, so the file should be set under version control if required.


License

User Manual » Introduction » First Steps » License

Description

The licensing of DaVinci Configurator consists essentially of two parts:

The Package License

A Package License applies to a Software Integration Package (SIP). Content of a SIP are configuration and integration of modules based on a defined use-case. Several Package Licenses can be installed simultaneous. There are no location restrictions.

Each SIP is registered in the Windows Registry in 'HKEY_LOCAL_MACHINE\SOFTWARE\Vector\DaVinciCFG\SIPs'. Each SIP setup will create a fitting entry in the Windows Registry. The SIP entries can be modified in Windows Registry editor at any time. DaVinci Configurator will read the registry entries each time the tool is started.

The selection of Package License is done in this way:

  • Starting DaVinci Configuratorwill set active Package License to last selected one (prior saved in .profile)
  • If no .profile entry exists for last selected Package License and more than one SIP is entered in Windows Registry, a selection box will be displayed on DaVinci Configurator startup
  • If no .profile entry exists for last selected Package License and only one SIP is entered in Windows Registry, the Package License will be selected by default
  • Since the project file contains information of the corresponding Package License, the Package License will be selected by default on loading an existing project
  • The -sip command line option forces the DaVinci Configurator to select the specified Package License without consideration of project settings as described before
  • If no project is opened (and more than one SIP is available), the menu entry 'File - Select Package License' will allow to change the current Package License (which is used for creating new projects)
  • If a project is opened (and more than one SIP is available), the menu entry 'File - Select Package License' will allow to reopen the project in a different Package License

DaVinci Configurator

DaVinci Configurator Pro and DaVinci Configurator Kit require a valid activation key.

Please contact MICROSAR support for further information.


Project File Handling

User Manual » Configurator » Features » Project File Handling

Description

The DaVinci Configurator allows to configure an Embedded System. All configuration details (of the architecture, the module configuration, etc) are saved in a so-called 'project'.

There are three kinds of projects:

1: AUTOSAR Project

An AUTOSAR project is always stored in two files: the project file which contains tool specific information about the project such as used controller. The ECUC file stores the whole module configurations according to their AUTOSAR vendor or standard definition file set.

The two files are stored in the same directory and are named as follows:

  • Project file
    • <filename>.vixml
  • AUTOSAR ECUC file
    • <filename>.arxml
Info

Info

The <filename> has to be the same in both file names.

2: AUTOSAR Project created with DaVinci Project Assistant

The Project Assistant creates the file structure, the ECUC files and if DaVinci Developer is available a corresponding workspace based on an ECU Extract of System description.

The DaVinci Project Assistant allows to create the ECUC as single file or one file per module. In that case the initial configurations of a module will be stored in a separate file.

  • Project assistant project file
    • <filename>.dpa
      (can be read from DaVinci Developer, GENy and DaVinci Configurator)
  • AUTOSAR ECUC files
    • .\Config\ECUC\<filename>_ecuc.arxml (or .\Config\ECUC\<filename>_<MSN>_ecuc.arxml for each module in case of splitted ECUC)
    • .\Config\ECUC\<filename>_ecuc.Initial.arxml
  • GENy project file
    • .\Config\ECUC\<filename>_ecuc.vdsxml
  • DaVinci Configurator project file is created after first save within DaVinci Configurator
    • .\Config\ECUC\<filename>_ecuc.vixml

3: Non AUTOSAR projects

Non AUTOSAR projects are stored in only one file with '.vixml' extension. No other naming convention is specified.

| Include AUTOSAR Module | Preferences |


Main Menu

User Manual » Configurator » Main Menu

The main menu offers all general DaVinci Configurator functions like

[File] [Edit] [View] [Project] [Build] [Tools] [?]

  • creating a new project
  • setting configuration phase
  • starting data validation
  • starting generation process
  • creating project reports

| DaVinci Configurator Overview |


File

User Manual » Configurator » Main Menu » File

New Project

Create a new Project.

New from existing project

Create a new project using an existing project as template.

Project Assistant

The DaVinci Project Assistant supports the following use cases:

  • Initial setup of a project:
    This allows the user to create a new ECU project out of one or more ECU Extracts of the AUTOSAR System Description file. At this step the file structure, the ECUC files and if DaVinci Developer is available a corresponding workspace is created. Short cuts to start an involved tool directly with the corresponding project are created too.
  • Update of a project:
    If the input files have changed (e.g. modified AUTOSAR System Description file) this workflow performs the update steps of the ECUC file and the DaVinci Developer Workspace (if available).
  • Edit the project settings:
    Within this workflow the user has the possibility to view all settings and change the general justifications of the project which don't necessitate to make any update calls e.g. the version or description of the project.

Open

Open existing AUTOSAR ECUC projects ( *.arxml, *.xml) or non-AUTOSAR projects (*.vixml).

Save

Saves the project to file(s).

Save as

Saves project on specific drive, directory or project name.

Close

Close current project. Returns to welcome window.

Import

Import a Module configuration from another project into current project.

Select Package Licenses

Select installed Package Licenses (Several Package License SIP)

Recent File List

List of recently Opened projects for quick access.

Exit

Exit DaVinci Configurator.


Edit

User Manual » Configurator » Main Menu » Edit

Cut

Cuts marked content.

Copy

Copies marked content to clipboard.

Paste

Pastes the cut or copied content.

Find

Opens the Find window.

Delete

Deletes the marked content.

Select all

Marks all selected content.

Copy full Filename

Copies the full filename to the clipboard. If project is not saved yet, the project name is copied to the clipboard.


View

User Manual » Configurator » Main Menu » View

Navigation

Shows or hides Navigation panel.

Toolbar

Shows or hides Toolbar panel.

Messages

Shows or hides Messages panel.

Refresh

To refresh current displayed data, click on Refresh or press <F5>. The refresh synchronizes all editors within all controls with their current values from internal data model.


Project

User Manual » Configurator » Main Menu » Project

Detect Unresolved Reference in ECUC

Check for unresolved references in the current ECUC file.

Info

Info

The project will be saved before validation.

Test Multiple Configuration Sets For Uniqueness

The names of the different multiple configuration sets of all modules within a ECU Configuration must be unique according to AUTOSAR requirement.

Adjust UUID's

Adjust duplicate or missing Universally Unique Identifier (UUID). The UUID's are checked for AR-PACKAGE, ECU-CONFIGURATION, MODULE-CONFIGURATION and CONTAINER elements.

Detection of Development Errors

Set error detection switches of all related modules to 'On' or 'Off' (Production Mode).

Synchronize MemHwA (Fee/Ea) with NvM

Start synchronization from memory configuration.

Recorder

Start Record or play selected record file.

Compare To...

Start Compare project with OTHER configuration.

[Board Name]

Switch to the Board view where the chosen Hardware can be configured.

Architecture

Switch to the Architecture panel.

Options

Opens the Project Options window.


Options

User Manual » Configurator » Main Menu » Project » Options

Description

The 'Project->Options' are divided into following sections:

Common Settings

Contains all general information about current project. The 'Logging' options, which log messages into different files, can be activated here.

Controller

Change the controller of the current project. The controller list depends of the selected package license.

Directories

Specify target directories which shall be used in generation process of each module.

AUTOSAR ECUC

  • Each module configuration that is part of the current ECUC is displayed with its relevant base and file information.
  • Add Admin Data and a description for current ECUC file. The Admin Data contains administrative information about your project such as who has made changes on the configuration at a specific date.

| Toolbar | Navigation |


MyEcu Description

User Manual » Configurator » Main Menu » Project » Boards

Description

In the view of the Board the chosen microcontroller can be configured (e.g. the oscillator frequency or the number of pins and some general OS settings). Furthermore the constant values of the microcontroller can be checked.

Info

Info

The view becomes optional in 4.2 release of DaVinci Configurator.


Build

User Manual » Configurator » Main Menu » Build

Validate

Opens a dialog which offers all modules that can be validated. For selected modules the Validation process will be started.

Info

Info

Via Main Menu->Tools->Preferences (Register 'Modules') the validation can be switched on / off for each module. If the validation is switched off for a module, this module will not appear in the dialog that offers all modules which can be validated.

Generate

Opens a dialog which offers all modules that can be generated. For selected modules the Generation process will be started.

Info

Info

Via Main Menu->Tools->Preferences (Register 'Modules') the generation can be switched on / off for each module. If the generation is switched off for a module, this module will not appear in the dialog that offers all modules which can be generated.

XSD Schema Validation

Start validation of the current project with the related AUTOASAR XML schema definition (XSD) file.

The XSD file and the files which shall be validated have to be specified in the according window selectable via menu 'Tools->Validate XML Files...'.


Generation

User Manual » Configurator » Main Menu » Build » Generation
User Manual » Configurator » Features » Generate BSW Modules

Description

Creates the configuration files of all software components activated in the current project. The generated files are stored in the target folders, which are specified in 'Project->Options'. The project has to be saved before starting the generation process. The generation process also triggers the validation process of the project (which has to be successful) before any files are generated.

How to generate

Select 'Build->Generate' or press <F9> to start the process of generation and to create all required source files.

If 'Start generation immediately' is selected the generation is started automatically.

Expert Knowledge

The switch can also be set in 'Tools->Preferences->General' by changing 'Start validation or generation without user confirmation.

More Options

Select the generation steps you want to include in the process. These selections will be saved in your local profile setting and will be read the next time you generate to ease the workflow.

These options change the process workflow at all.

  • Validate ECUC schema before starting the process:

    The Single ECUC file or each ECUC file splitter is validated with the according AUTOSAR XSD schema file to assure a well-formed configuration
  • Skip errors, continue with next module

    If the execution of a step fails the process will be continued nevertheless.

Additionally you can easily jump to the related Preference settings and change all relevant attributes without closing the generation dialog.

Messages

All messages are displayed in the general 'Messages' window.

  • Messages will also be saved in a log-file if 'Log General Messages' is activated in 'Project->Options'.
  • If 'Log Generation' is activated in 'Project->Options', a summary of the generation will be saved in a log-file.
  • Double-click the message line to open the displayed generated file.


Validation

User Manual » Configurator » Main Menu » Build » Validation
User Manual » Configurator » Features » Validate Configuration

Description

The complex dependencies of the configuration data become manageable because of a sophisticated validation process. A consistency check of the configured project is executed and each software component is checked by a set of validation rules. Additionally to the built-in validation process a 3rd party validator can be called for validation purpose.

The Validation process is divided into different levels which are performed one after another.

The 1st Level validation covers a set of constraints for each parameter value that depends on its definition:

  • all values apply to data type
  • all values are part of an enumeration list as defined
  • all values are within min and max limits as defined
  • all values match to a valid file name as defined
  • all values satisfy the rules for valid C names
  • all values satisfy the rules for valid AUTOSAR short-names
  • all values are unique
  • an input is required

These checks must be done to secure that each parameter value is conform to its description. If any value is corrupted the subsequent validation levels become useless. Nevertheless the execution of the validation process can be continued by setting 'Skip errors during first level validation' in 'Tools->Preferences' Boards dialog.

The 2nd Level validation contains complex rules for a set of parameter or container values. Cross-dependencies between parameters of a module or of different modules will be validated. The configuration can be tested for consistency in a high complex way. Intermediate data can be calculated to detect discrepancies in the configuration before generating any outputs.

The 3rd level validation can be optionally initiated to scan all references in the AUTOSAR ECU description file and to perform a lookup for the referenced parameter or container references. So any unresolved reference is detected and a related warning is displayed in the message window.

The user level validation can be executed to extend the validation process with own check algorithm or to include any other executable to adapt the tool chain. The user level validation needs to have a valid DaVinci Configurator Kit license to modify or extend the validation of module.

Minor errors of any validation level are notified as warnings and do not stop the validation process.

How to validate

Select 'Build->Validate' or press <F8> to check the consistency of the current configuration or parts of the configuration.

The validation dialog allows you to specify a set of modules that shall be part of the validation process.

Expert Knowledge

Select 'Validate' to start the validation of the current selected module in the context menu of the Architecture view.

| Generation |Architecture|


Tools

User Manual » Configurator » Main Menu » Tools

Reset Message Windows

Clears all messages in the message box.

Validate XML Files

Opens the AUTOSAR Wizard to validate AUTOSAR files with the related XML schema definition file.

Convert ECUC Description

Opens the AUTOSAR Wizard to convert the AUTOSAR namespace definition of an ECUC description file. The XML structure of the selected ECUC file is transformed into the XML structure specified via the namespace revision. This means that a formal transformation is done. The result is the same ECUC configuration in a new format which is valid to the XML schema definition specified via the namespace revision.

Include 3rd Party Module

Opens the AUTOSAR Wizard to include 3rd Party module to the current project. In this Wizard any BSWMD file can be chosen and it will appear in the Architecture. Optional, if an external generator is used to generate this module, the Target folder for the generated files has to be specified as well as the external generator program itself.

Info

Info

3rd Party Modules can be included in two ways: within this Wizard or via Tools->Preferences (register 'Modules') window.

Launch GENy

This entry only appears if GENy is installed. It starts GENy with the current project. While GENy is running the Configurator is frozen. To unfreeze close GENy or press the Esc key. If the Esc Key is pressed all changes which were made in GENy will be lost.

AUTOSAR

Select which report file (html, txt or xml) for which module shall be created. The available reports for each module are specified in the installed Package License(s). The created report is opened immediately in the standard editor specified in current Windows System. It is stored in the project sub directory.

Info

Info

This item has not to be named 'AUTOSAR' but e.g. 'Reports'. The name is also specified in the installed Package License(s).

Code Templates

Select which code template for which module shall be created. The available code templates for each module are specified in the installed Package License(s). The created code template is opened immediately in the standard editor specified in current Windows System.

Preferences

Opens the DaVinci Configurator - Preferences window.


Preferences

User Manual » Configurator » Main Menu » Tools » Preferences

Description

The preferences dialog is a very important and central dialog for default settings. It can be reached via 'Tools->Preferences' menu item. All of these settings done in preferences dialog will be used as defaults for new projects.

All changes that do not affect the configuration but are done to enhance usability will be stored in the .Profile file in the user application folder.

All other project relevant modifications will be saved in __Engine/.System file in the related Package License folder.

Info

Info

Delete .System or .Profile file to get back to the delivered default system or user settings.

The preferences are subdivided into following registers:

Register General

The general default program and project settings can be defined on that page. There are two kinds of settings:

  • Open last project on program start
  • Skip last window positions:
    If set DaVinci CFG will always be displayed on default window position.
  • Beep on error:
    If an error occurs, an audible signal sounds. The error is described in the Message Window (4).
  • Watch ECUC file for changes:
    If currently opened ECUC file is changed and saved e.g. via another editor, DaVinci CFG asks you if the ECUC file shall be reloaded.
  • Show module selection dialog before Validation /Generation:
    If set, every time you want to validate/generate the dialog with all modules is shown where you can de-/select the modules which shall be validated/generated. Please note, that only modules, which validation/generation is activated in Register Modules/General (see below) are shown in this dialog.
  • Synchronize references on rename on containers:
    If set, the renamed short name of a container will be modified accordingly in all related reference values.
  • Open generated report file with associated program:
    If set, the created file will be launched as command line parameter with the program that is associated with its file extension in Windows registry.
  • Project name only: Window Title of DaVinci CFG is the project name only.
  • Full project path name: Window Title of DaVinci CFG is the full project path name.
  • Author
  • Company
  • AUTOSAR: selected AUTOSAR revision specifies the AUTOSAR format of the ECUC file when your project is stored.
  • Default Target: add a relative (to Selected Package License folder) or absolute path. This path is used as Root Target Folder in the Options dialog/Directories.
  • Manuals: add a relative (to Selected Package License folder) or absolute path where the Manuals are stored. This path overwrites the default path.
  • Samples: add a relative (to license.bin file of the Selected Package License) or absolute path where the Samples are stored. This path overwrites the default path.
Info

Info

Default Target, Manuals and Samples are stored in the .System file. All other settings of this register are stored in the .Profile file.

Register Boards

All properties of the licensed Board modules e.g. their Home directories can be modified here. Additional settings can be done via following Sub-Register:

  • Validation:
    • Skip errors during first level validation: if true, first level validation errors (perform all checks as defined in the Board parameter definition e.g. Min and Max value) are done
    • Perform 3rd level validation (find unresolved reference values).
  • Generation:
    • Reset message window before starting generation
    • Skip errors, continue with next Module: if false, the generation is stopped as soon as the first error occurs when generating a module. If true, the generation is always done for all modules independent if errors occur.
    • Write tag GENERATION_DATE: if true, this tag in the Templates is not filled with data
    • Append GenId to tag: add comment with GenId to all generated code
    • Create BAK file of any code templates
    • Do not overwrite existing files if content is unchanged: if true, an existing file will not be modified (= timestamp will not be changed) in case the Generation would not change its content
  • PreGeneration:
    • Do PreGeneration (the following steps will be executed each time before starting the generation process): if true a specified Generation.xml or DLL or an external tool can be specified which are executed before the generation of all modules is started.
      • Target Folder: add a relative (to license.bin file of the Selected Package License) or absolute path

        • This path specifies two subjects:
          • 1. the directory where the output is stored if option Use XML Interface is used.
          • 2. If options Use DLL or Use external tool is used this path specifies the variable $(TARGETDIR) which can be passed to the DLL /external tool.
      • Use MICROSAR XML Interface: if true, the specified Generation.xml is executed before starting the generation process.
      • Use MICROSAR DLL Interface: if true, the specified DLL is executed before starting the generation process.
      • Use external tool:: if true, the specified external tool is executed before starting the generation process.
        • Transformation: specify a file (e.g. XSLT) which performs a transformation on the ECUC file before passing the ECUC file to the external tool.
        • Command: specify the command to start the external tool
        • Parameter: specify the parameter which shall be passed to the external tool. You can also use any of the internal variables as described in Variables.
        • Grab messages: if true, the messages from the external tool are displayed in the Message Window (4) of DaVinci Configurator.
  • PostGeneration: same settings possible as for PreGeneration.

Register Modules

All software component properties can be defined here. Select a Module in the left panel. Following settings can be done in the right panel:

  • Architecture Class: change the position of the module in the Architecture (3).
  • Select or insert a platform. With the left icon a new platform can be added if there is another platform licensed. With the right icon an existing platform can be deleted. The following settings can be done for each platform:
    • Register General:
      • Description: if no description is available in e.g. BSWMD file for the module, this Description would be added into module´s Hint in the Architecture (3)
      • Show as active: if true, module is activated (see also Architecture).
      • Config Variant: select Configuration Variant of the module which shall be loaded when creating a new project (only relevant if Module Definition file contains several configuration variants and no variant is specified in the pre-configured or recommended configuration).
      • Do Validation: if true, validation is performed for that module (and the module is displayed in the module selection dialog when starting validation).
      • Do Generation: if true, generation is performed for that module (and the module is displayed in the module selection dialog when starting generation).
      • Home folder: add a relative (to package license folder) or absolute path where the configuration files of the module are stored. The path can contain the name of the BSWMD file.
      • Target Folder: add a relative (to package license folder ) or absolute path where all generated files of the module shall be stored.
        The setting will be used as default value for creating a new project and can be modified in the Project->Options dialog if required.
    • Register Validation:
      • Use MICROSAR XML Interface: if true, the specified Validation.xml is executed when starting validation of this module.
      • Use MICROSAR DLL Interface: if true, the specified DLL is executed when starting validation of this module.
        • Use external tool: if true, the specified external tool is executed when starting validation of this module.
          • GENy generator: if checked all related modules will be collected and be generated with GENy all at once.
          • Supply AUTOSAR revision x.x.x: Since a 3rd party generator may require an ECUC file with a special AUTOSAR revision a temporary ECUC file will be created and passed to the specified generator.
          • Transformation: specify a file (e.g. XSLT) which performs a transformation on the ECUC file before passing the ECUC file to the external tool.
          • Command: specify the command to start the external tool
          • Parameter: specify all the parameter which shall be passed to the external tool. You can also use any of the internal variables as described in Variables.
          • Grab messages: if true, the messages from the external tool are displayed in the Message Window (4) of DaVinci Configurator.
    • Register Generation: same settings as in Register Validation
Info

Info

The working directory on calling an external tool for validation or generation purpose is set explicitly:

- For an absolute path the tool is started in the directory as specified in Command option.

- For a relative path the tool is started relative to the current Package License folder.

Register Kit (only available for Kit-License)

There are some additional debug options for the DaVinci Configurator. There are switches to log special messages on viewing, validation and/or generating process. The messages will be stored in a CSV file, that can be processed very easy with any other 3rd party tool (e.g. data filtering).

| Variables |


Variables

User Manual » Configurator » Main Menu » Tools » Preferences » Variables

Description

There is a set of parameters that can be used to pass information of the current project to the external tool. (you can use $(VARIABLES) e.g. $(TARGETDIR) via click on the icon right of the Parameter panel.

Expert Knowledge

The parameter list can be accessed in validation and/or generation tab of each module in Preferences dialog. Selecting a parameter within the parameters popup menu will paste the correct parameter notation to the current cursor position of the parameter input field.

Parameter | Description | Example
$(EcuProjectName) | The short name of the project without file extension that is derived from the project file name | MyProject1_ecuc
$(DpaProjectFolder) | Path of the Dpa config folder that is created with the DaVinci Project Assistant | C:\Dpa1\Config\
$(ProjectFile) | The project file name of the DaVinci Configurator | MyProject1_ecuc.vixml
$(EcucFile) | The ECU Configuration file of AUTOSAR | MyProject1_ecuc.arxml
$(EcucFolder) | Path of the folder with all files of the project | C:\Project1\
$(GenDataFolder) | Path of all generated BSW and RTE module files | C:\Dpa1\Appl\GenData\
$(XslResult) | Full path including filename of the result of a specified XSL transformation | C:\XslTrans.xsl.output
$(ServiceSwcFolder) | Path of all generated AUTOSAR XML files with the service components descriptions | C:\Dpa1\Service\Components\
$(WorkingFolder) | Path of the sip folder that contains all necessary DaVinci Configurator files | C:\SIP\Generators\Components\
$(ExeFolder) | Installation path of the DaVinciCFG.exe | C:\Program Files\Vector\DaVinci Configurator\
$(ConfigPhase) | Name of the selected configuration phase | PreCompile
$(Controller) | Name of the current selected controller | Generic
$(Package) | Name of the AUTOSAR package path of the project | /Active_EcuC
$(Timestamp) | Current timestamp with format 'yyyy-mm-dd hh:nn am/pm'; | 2011-03-11 15:00 pm
$(TemplateFolder) | Path for generated application templates | C:\Dpa1\Appl\Source\
$(LogFolder) | Path for generated log files | C:\Project1\Logs


AUTOSAR XML Schema validation

User Manual » Configurator » Main Menu » Tools » AUTOSAR XML Schema validation

Description

All AUTOSAR files can be validated with the related XML schema file according to its release number.

Select one option to specify the scope of the files that shall be validated.

Select single file option to specify an AUTOSAR file that is not part of the DaVinci Configurator installation.

The validation will cover the following file types:

  • ECUC files
  • Parameter Definition files
  • Basic Software Module Definition files
  • Software Component Template files

A report is created with a list of all validated files and the corresponding error messages if found.

For technical information about XSD in general see http://www.w3.org/XML/Schema.

Validation report

Save the validation report to a selected text file just by clicking the 'Save as...' button. It will be appear at the end of the XML validation.


Reports

User Manual » Configurator » Main Menu » Tools » Reports

Description

A report automatically creates a html-file (also TXT or XML files can be created), which contains all the information about the configured software components. The generated report is placed in the project sub directory ./Reports. The report file is generated by a XSL Transformation, an open standard (see http://www.w3.org/TR/xslt).

How to start a report

Select 'Tools->Reports' in the Main Menu.


Help

User Manual » Configurator » Main Menu » Help

Help

Opens this online help.

Parameter Help

Opens additional window showing more information about the selected parameter.

Manuals

Collection of additional Online Help documents. The available documents are specified in the installed Package License.

Samples

Opens sample AUTOSAR ECUC file. The available file is specified in the installed Package License.

Technical Support

Shows contact details for support.

Delivery Description

Shows full description of selected package license. In some older deliveries the description file may been missing.

Info

Opens the Info box.

With the button [More Info...] a further window opens, containing all important information about the System, Version and installed modules.

Expert Knowledge

The version info list of all installed files can be saved permanently to file via related context menu in version info table for support purpose.


Toolbar

User Manual » Configurator » Toolbar

Description

Image | Description | Shortcut
 | Create new project | <Ctrl> + <N>
 | Open dialog to select existing projects | <Ctrl> + <O>
 | Save changes to the current project | <Ctrl> + <S>
 | Start Validation process | <F8>
 | Start Generation process | <F9>
 | Show Architecture view |
 | Show Board settings |
 | Show project Options dialog |
 | Record all changes of configuration |
 | Play record file |
[Phase] | Set the Configuration Phase |

| DaVinci Configurator Overview |


Config Phase

User Manual » Configurator » Toolbar » Config Phase

Description

Set configuration phase according to your current project situation.

There are three available phases defined during edit of configuration:

  • Pre-Compile
  • Link
  • Post-Build

According to the selected phase a parameter is locked from being changed in any editor depending from its definition.

Info

Info

The configuration phase should not be reset to a previous phase, if part of generated source code is already compiled and thus not configurable in source code any more.


Navigation

User Manual » Configurator » Navigation

Project Explorer

Navigation through the active project.

  • The Architecture editor gives an overview of all used or unused configuration instances.
  • The Board view shows all platform specific settings.
  • The editors of all module configuration are shown in different explorer views e.g. 'Architect' and 'Technical Fellow' that can be switched within the explorer toolbar.
  • The project Log folder is displayed within all generated log files for messages, validation and generation. The listed files can be opened via context menu with the application associated in windows registry.

Expert Knowledge

The context menu of each node provides different items regarding to its context.

- Activating or de-activating modules

- Opening folders or files with associated application

- Compare project, run project XSD schema validation and more

- Open package license folder

Property Manager

The Property Manager shows the most important project properties.

  • To change a project property open Options dialog via toolbar icon.
  • The real target folder specifications are displayed. The target folder can be accessed via context menu.

| DaVinci Configurator Overview |


Architecture

User Manual » Configuration » Architecture

Description

The Architecture view contains all embedded modules of the project.

Image | Description
 | AUTOSAR module
 | Inactive module. Module will not be saved in the ECUC file.
 | No AUTOSAR module. A module which data definition do not refer to an AUTOSAR Standard Module Definition.
 | Invalid module. The module definition file is missing, the module configuration cannot be edited.

All Architecture related actions of a module can be done via the context menu, which is opened after right-clicking any selected component:

Key | Menu Item | Description
F6 | Configuration... | Opens default or selected editor for module configuration
 | Activate / Deactivate | An active AUTOSAR module configuration is saved to the ECUC description. Deactivate the module to switch off storing the configuration in the ECUC description file. Nevertheless the configuration will be permanently saved in the '.vixml' project file for further use.
F2 | Rename | Rename module configuration. The ECUC description uses the name of configuration to identify each module configuration instance with a unique name.
Shift + F1 | Implementation | Display detail information of the module definition e.g. its version numbers, Admin Data records and list of definition files
 | Module Preferences | Opens 'Tools->Preferences' with a pre-selection of the current module.
 | Validate Definition | Execute AUTOSAR XSD schema validation for all module definition files according to its schema version number
 | Explore | Open explorer window of the specified module folder (Home, Target) for quick access
 | MyLinks | List of installed or user-added file references of selected module. The selected submenu item runs the associated program to open the selected document. Executable references will launch the file itself. MyLinks can be modified in 'Tools -> Preferences -> Modules'. Drag'n'drop one to many files from explorer on current module icon to create MyLinks entries quite simply. Installed MyLinks entries cannot be deleted.
 | Export | Save current module configuration to specified ECUC file (AUTOSAR Format) Save current module configuration to project VIXML file (DaVinci Configurator Format)
 | Import | Replace current module configuration with specified ECUC file considering Pre-configured Configuration values (Replace) Add specified ECUC file additionally to current module configuration (Append)
 | Remove PreConfiguration | Save module configuration without any pre-configured objects in purge mode.
 | Revert Configuration | Reset module configuration to initial values.
 | Compare To | Compare current module configuration with saved or other one.
 | Validate | Start validation of current module configuration
 | Deactivate All Other | Deactivate all modules except selected module
 | Activate All | Activate all modules
 | Include 3rd Party Module... | Start wizard to include new AUTOSAR modules into the project. See also Include 3rd Party Module
 | View Style | Select the style of architecture view. Report style also show 'Software Version', 'Implementation Variant' and 'Description' of the modules

| DaVinci Configurator Overview |


Messages

User Manual » Configurator » Messages

Description

The message box shows several messages while working with DaVinci Configurator.

Messages could be information, warning or error messages. The messages that are raised from the validation or generation process are additionally shown in the 'Result List' register.

All messages can be logged to files. The related settings can be done in Project Options (Property Manager) in Logging page.

  • The register 'General' shows all messages as chronological sequence with the source of the message. Some messages can have child messages to enhance the clarity. These child messages can be collapsed or expanded as desired. Each message contains a number and the name of the sender of the message e.g. the name of the module.

  • The register 'Changes' shows history of all modified configuration parameters with timestamp and changed values. The row number specifies the multiplicity value of the changed value.

  • The register 'Result List' shows a summary of all messages grouped by their type. The Result List is refreshed each time a validation or generation is started. It shows the count of the different message types in the message type headline. The single lines are sorted according to the message timestamp.

Right click on message box, a context menu opens to delete, copy to clipboard or save to file the selected message. Selecting more messages is supported (<Shift>+<mouse click> to select a set of messages or <Ctrl>+<mouse click> to select single messages).

An error message can be double-clicked to view the source of the error, if an arrow icon is displayed in the message line.

A message with an icon on the left in the message line can be double-clicked to open the application that is associated with the related file extension.

| DaVinci Configurator Overview |


Editor

User Manual » Configurator » Editor

Description

The DaVinci Configurator is able to open and edit multiple modules at the same time. Each module editor is appended to the tab folder. The tabs can be also controlled via hotkeys.

The dropdown list (2) allows the user to select a detail view of the module configuration.

Views are used to structure a large amount of parameters into separated views. In every case this list contains an element 'Generic Editor' which shows all parameters in a generic mode with a generic feature set. The parameters (1) in the picture below belong to the view 'General Settings'.

The dropdown list (3) shows a history of all selected parameters in the selected editor. If any control is selected the corresponding parameter name and its path is added to the list by default. Select an item of the dropdown list to jump to the related control.

The toolbar button (4) offers following actions:

  • Validate
    • This entry starts the validation for the selected module.
  • Reload comfort editor (not available for 'Generic Editor')
    • This entry reloads the comfort editor from the beginning.
  • Timing Analyzer (only available for module Os)
    • This entry starts the Timing Analyzer.

Parameter values of type Integer can be printed in decimal, binary or hex format in any editor. The format can be switched via the context menu, a provided button or in case of a table a double-click on the header of the table column with <Ctrl> hold down. If the format was changed the new choice is saved in the .profile and will be used in every representation of the parameter.

Com Editors

The module Com provides two further special editors to handle a huge amount of entities more comfortable.

  • The 'ComSignal Editor' contains just all Signals and SignalGroups.
  • The 'ComIPdu Editor' contains all IPdu and IPduGroup objects.
Info

Info

The objects of the special Com editors are only displayed in the corresponding editors and are not shown in the Generic Editor of the Com.

| Main Menu | Toolbar | Architecture | Navigation | Messages |


Features

User Manual » Features

Following are some of the key features that make DaVinci Configurator unique.

Accessing Parameter

  • Find Parameter according to Definition, Name, Value or Comment
  • Jump To Specified Object
  • Set Read-Only Mode of Module Configuration

Changing Set of Parameter

  • Change Multiple Selected Configuration Objects
  • Synchronize MemHwA with NvM
  • Apply Recorded Changes to Configuration

Changing Configuration of a Single Module

  • Import Configuration with Append, Replace or Update
  • Purge Configuration On Saving Project with Removing Pre-configured Configuration
  • Revert Configuration To Init State

Comparing Configuration

  • Compare (and merge) Configuration with OTHER Configuration

Building Project

  • Detect Unresolved References in Configuration
  • Validate XML Files with AUTOSAR XSD
  • Validate Configuration of BSW Modules
  • Generate BSW Modules and run 3rd Party Generator Tools

Miscellaneous

  • Detect Modifications of Project File(s) by Other Applications
  • Create Desktop Project ShortCut


Find Entities

User Manual » Configurator » Features » Find Parameter

Description

The Find Entities dialog provides a possibility to lookup entities by different filter settings. The window can be accessed via Ctrl-F or 'Edit->Find' main menu item.

The search is performed with different filter settings and can be modified for special search requirements.

Selected entities are focused with a simple double-click or via context menu in the corresponding comfort or generic editor.

Search Settings

• Module Scope

  • The result list shows only entities of the selected module or all.

• Criteria

  • Comment - All entities with matching comment value:
    All Modules + Comment + C + 'To-Do' Find all entities with your to-do comments.
  • Definition Reference - All entities with matching definition reference value:
    All Modules + Definition Reference + end + 'channel' | Find all channel objects of your configuration.
    NvM + Definition Reference + end + 'blockdescriptor' | Find all existing memory blocks.
  • Description - All entities with matching description text:
    All Modules + Description + !C + 'not used' | Find all entities except not used ones.
    All Modules + Description + C + 'Mcu' + 'Case Sensitive' | Find all Mcu related objects.
  • Name - All entities with matching names:
    All Modules + Name + end + 'errordetect' | Find all ErrorDetection switches of your configuration.
    All Modules + Name + = + 'comhandleid' | Find all existing ComHandleIds
  • Value [, "Display"]- All entities with matching value (if display value differs with value, both will be printed):
    CanIf + Value + = + '2' | Find all objects of CanIf configuration with values of 2.
    BswM + Value + 'start' + 'bswmrule' | Find all BswMRule objects of BswM configuration.

• Operator

C | Contains | The <Criteria Text> contains the criteria of the inspected object | 'abc' is contained in '1abc','abc1' or 'abc', but not in 'ab_c'
!C | Not Contains | Negation of C |
= | Equal | The <Criteria Text> is exactly the same as criteria of inspected object | 'abc' is equal to 'abc' but not to '1abc' or 'abc1'
!= | Not Equal | Negation of = |
start | Start | The <Criteria Text> starts with the criteria of the inspected object | 'abcdef' starts with 'abc' but not with 'aa' or 'ba'
!start | Not Start | Negation of Start |
end | End | The <Criteria Text> ends with the criteria of the inspected object | 'uvwxyz' ends with 'wxyz' or 'z' but not with ' uvwxy' or '1'
!end | Not End | Negation of End |
Null | Null | The criteria of the inspected object is empty or not found at all | -
!Null | Not Null | Negation of Null | -

Options

  • Live - The result list is updated each time the search text changes.
  • Case-Sensitive - The inspection of the criteria will be done case-sensitive or not.

Context Menu Result List

Jump To Entity | Jump to configuration editor and select referenced parameter for changing, it will be refreshed or closed just on user demand.
Parameter Help... | Open the corresponding parameter help dialog with all important definition and object attributes (Shift + F1).
Show Value | Show or hide column Display/Value in result list.

Expert Knowledge

Press F5 to explicitly update the result list. This is not done by default, so the result list can be used like a working list for a specified set of parameters.


JumpTo

User Manual » Configurator » Features » Jump To Object

Description

On loading ECU Configuration some user messages could be displayed about corrupted or invalid data related to a configuration entity. The validation of the configuration may also raise warnings or error messages about invalid values or missing data. In every case there is a quick way to Jump To the source of the problem to fix it immediately.

All message lines that are marked with jump to symbol [image] will bring you to next available editor via double-clicking the line or opening context menu.

Expert Knowledge

Double-clicking a line with symbol

opens explorer window with folder as specified in message

opens file as specified in message with associated application

opens xml file with associated application


Read-Only Mode

User Manual » Configurator » Features » Set Read-Only Mode of Module Configuration

Description

The DaVinci Configurator manages the access to a project by concurrently opened Vector tools, to prevent users from overwriting changes made in another tool.

If a project is changed by another Vector tool, DaVinci Configurator switches to the Read-Only mode.

The Read-Only mode is left, when the project get saved or closed in the other tool.

Read-Only Mode Indicator

Version 4.12.1204
© Vector Informatik GmbH


Edit Multiple Values

User Manual » Configurator » Features » Change Multiple Selected Configuration Objects

Description

There may be a use case to modify a set of parameter values with one or more same value. By selecting multiple objects changes could be made more effective and faster.

Info

Info

The new values are applied to each object in same manner as other change. So if one of the multiple selected objects will not accept the new value an error message will be prompted as normal. A short summary of all changes will be printed in an information message at the end of data change.

Selecting Multiple Objects

There are two ways to select multiple objects:

  • Generic Configuration Editor (GCE)

1. Create multiple selection list:
- Ctrl+Left Mouse adds selected object with same definition reference to the list.
- Select 'Select All Objects with Same Definition' from context menu.
The multiple selection list is just limited by matching definition reference not by tree level.
2. Open context menu 'Edit Multiple Selected Values...'

  • Tables

1. Create multiple selection list in exactly the same way as in explorer list view:
- Shift+Left Mouse selects all rows beginning with current selected one.
- Ctrl+Left Mouse adds selected row to multiple selection list.
2. Open context menu 'Edit Multiple Selected Values...'

Edit Multiple Selected Values

The bulk change dialog shows all common parameters except not visible or read-only ones. The user will be informed about values that are unique or mixed for all selected objects, already changed values will be written in bold way.

OK applies the new values for all relevant objects of the multiple selection list. Invalid values will be prompted to user message window as usual.

Create Multiple Container Objectes

The related context menus of GCE or table support an 'Add Multiple' or 'Insert Multiple Rows…' menu item. A dialog is asking for the count of objects to be created and the mode how the new objects will be created ('As a Copy' of the current or 'As New with defaults').

  • GCE

  • The context menu contains all available types of nested objects in consideration of their multiplicity constraints.
  • Tables


Synchronize MemHwA

User Manual » Configurator » Features » Synchronize MemHwA with NvM

Description

The DaVinci Configurator synchronizes the memory configuration to a well-formed and valid state.

If MICROSAR NvM is not part of your package license the functionality is not available.

Start synchronization by selecting 'Project->Synchronize MemHwA (Fee/Ea) with NvM'.

Synchronization Steps

  1. Collect all memory blocks with definition reference of '/MICROSAR/NvM/NvmConfigBlockDescriptor'.
  2. Get mapped device (Fee or Ea instance) for each memory block and ensure block existence in mapped device.
    1. Create block in mapped device if missing.
    2. Apply all important attribute values of mapped block with NvM block information.
  3. Remove mapped blocks from mapped device that refer to non existing NvM block.
  4. Calculate all Fee and/or Ea blocks specially id, address and size values.
  5. Print short summary.

Info

Info

Before changing the configuration the DaVinci Configurator will ask you save the project.


Record Configuration Changes

User Manual » Configurator » Features » Apply Recorded Changes To Configuration

Description

An ECUC recorder is designed to keep track of your personal project changes:

  • Project attributes like author, revision or description
  • Inserting, renaming or deleting container objects
  • Adding, changing or deleting parameter or reference values
  • Creating, renaming and deleting module instances

The recorder can be accessed via 'Project->Recorder' or related toolbar icons.

The single tracks are stored in XML format in a record file with extension '.ecurec' and can be easily applied to the current configuration or other. The record files can be opened via project explorer or toolbar icon.

  • Record your changes as a summarized transaction very simple and light weight.
  • Store your changes for any replay, later re-use and distribution.
  • Apply your stored changes to any configuration in safe or tough mode.
  • Use several labels to identify and document your stored tracks.
  • Use ECUC recorder as a simple workaround for your concurrent working on a configuration

Start Recorder

Track any change of the configuration chronology from that point. It is no matter whether the project is saved or not. The toolbar icon is changed to a blinking red rectangle until the record is stopped or the project is being closed.

Stop Recording

Stop tracking changes and ask for discard or saving a record file with a default description. If no other folder is selected the files will be created in the Logs folder of the project directory.

The save dialog shows main properties of the record and listed all tracks on a separate page where single tracks can be excluded from file storage. The length of the record relates to its selected tracks.

Save Record

All selected tracks are being saved in the record file in XML format in chronological order.

Load Record File

Select record file in project explorer if stored in project directory or via file selection dialog. All tracks were initially shown as disabled as the player was not started yet.

If current project configuration is still unsaved select 'Save Project before' to get back by closing project without saving if playing result does not fit.

The 'Perform each track in safe mode' will not create any objects by default (except the new ones) but print warning or error message for that case.

Select 'Break On Error' if no further track shall be executed if track cannot be executed and fails with error.

Play

Start applying all tracks to current configuration with selected options. The Tracks pages will be selected and the state for each track is printed. Select line with error for hint and see message window for additional information.

Caution

Caution

A track may not been executed if object definition is not found in current project.

In some cases an error may raise a set of following errors since required objects are missing.


Import

User Manual » Configurator » Features » Import Configuration

Description

The different import options offer the possibility to import a module configuration from another project into current project.

When selecting one of these options a file selection dialog is opened where you can choose an ECUC file. Afterwards a module selection dialog is opened which offers the modules of the selected ECUC file.

You can start import from 'File->Import' menu or from module context menu item in Architecture view:

Info

Info

You also can start import within Comparing a configuration with another one. This will give you a quick overview of the differences and therefore a decision guidance which option will be the best.

The selected module will be imported depending on the chosen option:

Option Description
Append
  • All allowed (the upper multiplicity of instance count is not reached) containers and parameters of the new module are added to current module configuration in the order of the import file.
  • If the module which shall be appended contains a container with same name as a container in current module configuration, this new container will be appended with a new name e.g. A1 becomes A11.
Replace
  • The current module configuration will be replaced by the new module configuration except published information or pre-configured object or values.
  • Published information or pre-configured objects will not be removed or changed at all e.g. B1 will be found in result although missing in import file.
Update
  • Basically the Update mode extends Replace option with the difference that an object value may only be set if value from import file is
  1. not empty
  2. different to default value and
  3. different to recommended value.
  • The current configuration will be extended by a default merge e.g. both A1 objects will be merged to a new A1 object with same name but different nested objects and /or values.

Caution

Caution

  • If a module configuration which shall be imported is raised from differing definition file(s), not all of the configuration data can be mapped resulting in information loss and inconsistent module configuration. Objects or values will not be imported if no matching definition will be found in current package license folder.
  • One thing is mandatory for all import options: Any published information or pre-configured object or object value will not be changed.

| Compare |


Purge Configuration

User Manual » Configurator » Features » Purge Configuration

Description

There may be a use case to save a module configuration without any pre-configured data values. So in fact the user may switch the pre-configuration (file set) of a module and gets different configurations when reloading the purged one.

A purged configuration stores all default and required objects together with the user changed ones. An existing module pre-configuration will be assigned as required to the purged configuration on loading a project.

The action can be started for the current project in the architecture view in the context menu of a module by selecting 'Remove PreConfiguration when saving ECUC file'.

Expert Knowledge

To remove the pre-configuration of a module for all coming up projects, the setting can be done in 'Tools->Preferences->Modules' General page for all or for a single platform.

| Architecture | Preferences |MicrosarGen|


Revert Configuration

User Manual » Configurator » Features » Revert Configuration

Description

There may be a use case to revert a module configuration to its initial state without changing all others module configurations.

  • The initial configuration state contains all pre-configured and default configuration objects without any user added.
  • The modifications of all other module configurations will not be affected.
  • The configuration can be reverted in the architecture view in the context menu of a module by selecting 'Revert Configuration to Initial Values'.
  • All user modifications will be lost after reverting a configuration.
  • The action cannot be unmade, so save your project as a precaution.

The action can be started for the current project in the architecture view in the context menu of a module by selecting 'Revert PreConfiguration to Initial Values'.

Caution

Caution

The revert of a module configuration will not include objects that are defined in ECU Extract within DaVinci Project Assistant.

| Architecture |


Compare (and Merge) Configuration

User Manual » Configurator » Features » Compare (and Merge) Configuration

Description

There may be a use case to analyze differences between the current configuration objects of a selected module or complete project and another configuration. The analysis is done on object level and its context.

Following less significant differences will be ignored at all:

  • AUTOSAR XML version related syntax
  • Attribute values raised from AUTOSAR module definition e.g. UUID values
  • TopLevelPackage and Package structure of ECU Configuration
  • Annotations and/ or AdminData values of ECU Configuration

The project that is already opened is called SELF, the project that is selected for comparison is called OTHER.

Info

Info

  • The compare is looking for changed objects (container names, parameter or reference values).
  • Some differences are marked as read-only differences and could not be merged, if the related objects are defined as published from AUTOSAR definition or derived from a pre-configured configuration set.
  • If new container object is found, all nested objects (sub-container and parameters) will not be inspected anymore.
  • The compare of 'big' configuration files may take a minute or longer depending of its size or content.

Compare Project

Select OTHER to compare all module configuration that are part of both ECU Configuration files via 'Project->Compare To...' main menu item.

Expert Knowledge

Drag AUTOSAR ECUC file from explorer and drop it into DaVinci Configurator.

The summary lists all analyzed module configurations of SELF and OTHER. Use predefined filter set to qualify summary. Select module tab for detail information about differences.

  • #Self: Self Objects: Count of all objects found in SELF
  • #Other: Other Objects: Count of all objects found in other
  • Diffs: Differences: Count of objects that differ (affected by 'Ignore Differences of...' state)
  • Show [Equals,Only Part of Self...,Differing]: Show or hide modules regarding to their difference type
  • Project Report: Print Html or Xml report with all compare results

Compare Module Configuration

  • Refresh: Restart comparison.
  • Report...: Print html or xml report for selected Module.
  • Ignore Differences of Read-Only Objects: Hide all differences raised from non-changeable object values.
  • Number of Objects: Count of objects grouped by definition type.
  • SELF: Full filename of current configuration.
  • OTHER: Full filename of compared configuration.
  • Each difference is represented by a row. The detail property view is related to the current selected difference.
  • Jump To: Open related editor and select object.
  • Help: Open parameter help window with all available attributes from definition.

Expert Knowledge

Select 'Compare To...' from context menu of the selected module to compare a single module configuration with OTHER in Architecture view.

Drag AUTOSAR ECUC file from explorer and drop it on module icon in Architecture view.

Merge

The configuration of SELF can be changed by a set of different merge options, the configuration of OTHER will be unchanged at all and treated as read-only file. The merge of a new container object will merge all nested objects by default. As a consequence of this new differences may be detected or be removed after restart of comparison.

  • Merge All: Merge of a complete module configuration
  • Replace: Replace entire SELF configuration with OTHER
  • Append: Add all objects of OTHER to SELF
  • Update: Update SELF configuration with OTHER (default merge)
  • Copy To Left:
  • Modify SELF object name or value according to OTHER name or value. The kind of modification depends from object definition type, definition criteria as multiplicity and the type of the difference itself. In some cases a dialog will be displayed to specify the merge of this object more detail.
  • Merge Selective:
  • Merge Apply all single change to SELF objects/values manually done by user with 'Copy To SELF'.

Report

The result of the analysis can be stored in a report in different formats:

  • The HTML report lists all differences and project relevant data in a user-friendly way
  • The XML report stores all differences and project relevant data for creating own-styled reports or additional work:
    • Create your own or modify delivered XSL files ('__Engine\_Trans') for transforming XML report files and changing set of displayed data.


Detect Unresolved References

User Manual » Configurator » Features » Detect Unresolved References in Configuration

Description

An unresolved reference may be created by removing objects from a configuration that are referenced by other module configurations. The consistency of a reference value and the referenced object should be checked as a precaution since not existing references will make waves in any case on link time.

  • The validation of references can optionally be done by default each time at the end as part of validation process.
  • The validation of all references that are part of ECUC can be done on user demand with 'Project->Detect Unresolved References in ECUC'.

Info

Info

Removing objects within DaVinci Configuratoreditor will delete all references for that object by default. Nevertheless an inconsistency may occur if the configuration is modified e.g. by another tool.


AUTOSAR XSD Schema Validation

User Manual » Configurator » Features » Validate XML Files with AUTOSAR XSD

Description

All AUTOSAR related files can be validated with the related XSD schema file according to its release number. The XSD validation certifies the authenticity and required integrity according to AUTOSAR specification.

There are several ways to validate different types of AUTOSAR files within DaVinci Configurator:

Menu | Project | Validate File(s) | Description
Currently loaded | ECUC | Run 'XSD Schema Validation' from Build menu. The ECU Configuration will be validated with the corresponding AUTOSAR.xsd file. A summary with errors if occurred is printed in message window.
Currently loaded | ECUC | s.o.

Currently loaded
or
selected one

 Any AUTOSAR file (e.g. other ECUC, Definition File, SWC...)

AUTOSAR XSD validation wizard with different options as described in single pages of the wizard. A summary with errors and save option is printed on last page of wizard.
Currently package license Definition File(s)

Run 'Validate Definition' from context menu of selected module in Architecture view. All definition files in home will be validated with the corresponding AUTOSAR.xsd files. A summary with errors if occured is printed in message window.

Caution

Caution

Invalid AUTOSAR definition files will be printed each time a project is created or opened within the DaVinci Configurator. In that case the configuration could be damaged or corrupted anyway.

Generation
Select 'Validate ECUC schema before starting the process' on Generation /More Options dialog to enforce the XSD validation with the corresponding AUTOSAR.xsd file before running the generation itself. A summary is printed within the generation message with errors if occurred.

Info

Info

  • Even if schema validation reports an error or warning message, the DaVinci Configurator aims to load the file anyhow - depending from the level of faultiness.
  • The XSD validation just verifies the formal correctness of the checked file (syntax) according the AUTOSAR schema definition. Semantic errors will not be found at that point.

| Generation |


File Change Detection

User Manual » Configurator » Features » Detect File Modifications

Description

The user will be informed by default if project ECUC files is changed by another program. The change detection is done per module and can have following results:

  • There are no changes in current module configuration. There is no synchronization required at all.
  • There are changes in current module configuration that can be handled with these options

    • ignore modification at all
    • import modification with append option
    • import modification with replace option

All changes that do not affect the current configuration will be skipped with a related user message. The current configuration can be saved to backup file before being changed.

Info

Info

The file change detection can be switched off in 'Tool->Preferences'.

| Preferences | Read-Only Mode |Import |


Desktop ShortCut

User Manual » Configurator » Features » Create Desktop ShortCut

Description

The DaVinci Configurator could provide you quick access to a project by creating a shortcut on your windows desktop, to open the project just by one-click.

As a result the your desktop will have a new icon like following:

Collect all your project on your desktop or copy the shortcut to any other folder if necessary.

Expert Knowledge

In fact the shortcut is calling the DaVinci Configurator wih following argument line:

"<Installation Folder>\DaVinciCFG.exe" -sip "<Package License Folder>" -f "<Full Project File Path Including Name"


Add Ons

User Manual » Add Ons

This chapter contains the description of additional functionality of DaVinci Configurator.

| AUTOSAR Modules | Batch Mode |


Hotkey List

User Manual » Configurator » Hotkey List

Description

Key | Description
<Del> | Delete selected text Delete selected node in GCE tree
<F1> | View online help file
<Shift> + <F1> | Context help for current module or parameter object
<F5> | Refresh data in current view
<F6> | Open file select dialog in any file select controls Open configuration editor in Architecture Open dialog to edit parameter values
<F8> | Validate project configuration
<F9> | Generate project configuration
<F10> | Add or modify AUTOSAR parameter comment
<Alt> + <E> | Open edit main menu
<Alt> + <F> | Open file main menu
<Alt> + <T> | Open tools main menu
<Alt> + <V> | Open view main menu
<Alt> + <?> | Open ? main menu for more help
<Ctrl> + <A> | Select all
<Ctrl> + <C> | Copy
<Ctrl> + <N> | Create a new project configuration
<Ctrl> + <O> | Open a project configuration
<Ctrl> + <S> | Save project configuration
<Ctrl> + <V> | Paste
<Ctrl> + <X> | Cut
<Ctrl> + <Tab> | Switch to the next page of the tab folder
<Ctrl> + <Shift> + <Tab> | Switch to the prior page of the tab folder

| DaVinci Configurator Overview


AUTOSAR Modules

User Manual » Add Ons » AUTOSAR Modules

Description

Any AUTOSAR module with available AUTOSAR parameter definition file can be included in DaVinci Configurator (with GCE license only).

Please refer to AUTOSAR_ECU_Configuration.pdf of AUTOSAR Specification to get more information about AUTOSAR parameter definition files.

The AUTOSAR parameter definition file should be named like *_paramdef.arxml or *_bswmd.arxml.

How to include AUTOSAR modules in DaVinci Configurator

To include an AUTOSAR module into DaVinci Configurator follow these steps:

  • Open preferences dialog via 'Tools->Preferences' menu item
  • Go to register 'Modules'
  • Add new module to module list (via new button)
  • Select the required modules from list or type in different ones in the displayed dialog
  • The <default> settings are used as default for all licensed platforms and can be overwritten by inserting a new platform description to supply e.g. the usage of different AUTOSAR generators.
  • Specify the home and target folder in the General Attributes of the new module.
    The home folder is required and must contain the related AUTOSAR parameter description file with *.arxml extension
  • Modify all other Attributes e.g. for Validation
  • Specify location and parameter set of the AUTOSAR generator in Generation Attributes.
  • Close preferences dialog
  • Create new project and your newly added modules are shown in Architecture and Components list
  • Edit and modify the parameter values in a generic editor window
  • Use context menu items to delete, add or copy Container(s) of your related module configuration

Info

Info

The configuration of any AUTOSAR modules are stored the so-called ECUC file with naming convention of <projectname>_ecuc.arxml. In some cases the ECUC description may consist of a set of module configuration files that will be merged on loading project. The initial creation of a splitted ECUC description can just be done within DaVinci Project Assistant.

The AUTOSAR ECU configuration description file can be read by any AUTOSAR editor or AUTOSAR generator tool.


Batch Mode

User Manual » Configurator » MICROSARGen Command Line Options

Description

DaVinci Configurator includes the command line utility MicrosarGen.exe, which provides the capability to perform different tasks using a command line interface.

How to use

MicrosarGen.exe is run from a Windows command line interface ('DOS shell') by typing 'MicrosarGen.exe [parameters] projectfilename'. It can also be used as part of a batch file. Valid command line parameters are listed below.

Parameters

The following parameters are recognized by MicrosarGen.exe as valid command line parameters.

MicrosarGen.exe

[-h] [-p] [-s] [-version]

[-v] [-g] [-t RootTargetFolder]
[-tmod ModTargetFolder] [-tswc SwcTargetFolder] [-tcod CodeTemplatesTargetFolder]
[-remPreCfg Module] [-syncMem] [-c Controller] [-m Module] [-cc ConfigPhase]

[-log] [-nobak] [-noxsd] [-sip PackageLicenseFolder] [-a ASRevision]

[-f ProjectFile|ECUC] [-save] [-o OutputFile] [-full]

Option | Description
-h

All available parameters of MicrosarGen.exewill displayed with a short description and dependencies to other parameters if existing.
-p

A summary of a specified file (-f) will be printed:

  • Project Name
  • Project Folder
  • AUTOSAR Version
  • Author
  • Company
  • Creation Date
  • Revision
  • Log Switches
  • Controller
  • Phase

Use -s to suppress info and warning messages during project load.
-s | All messages are suppressed and will not displayed anymore.
-version

The full version number including build number of MicrosarGen.exein format
'MICROSAR Generator Version major.minor.patch.build'.

Use of version parameter will skip all other parameter.
-v

Configuration of a specified file (-f) will be validated. All module configurations with a related setting in 'Tools->Preferences->Modules' are validated by default.

Use -m to modify the module list to a single module or an individual list of modules.

-g

Configuration of a specified file (-f) will be generated. According to settting in 'Tools->Preferences->Modules' the generation will be done within DaVinci Configurator or by running 3rd party generator.

Use -m to modify the module list to a single module or an individual list of modules.
-t

The setting of the root target folder will be concatenated with any relative target folders according to the module target setting.

Use absolute path to overwrite default setting.
-tmod

The setting of the target folder for generated files will be concatenated with root target folder or default settings.

Overwrite existing project or default settings.
Use absolute path to overwrite all other settings.
-tswc

The setting of the target folder for generated SWC files will be concatenated with root target folder or default settings.

Overwrites existing project or default settings.
Use absolute path to overwrite all other settings.
-tcod

The setting of the target folder for generated code templates will be concatenated with root target folder or default settings.

Overwrites existing project or default settings.
Use absolute path to overwrite all other settings.
-remPreCfg

All pre-configuration objects of a single module or an individual list of modules will be removed from specified project file (-f).

Use -save option to store the modified project file.
-syncMem

The synchronization of the MemHwA will be triggered before validation process starts.

Use of -syncMem requires /MICROSAR/NvM implementation as part of package license.
-c | If specified project file (-f) does not contain any controller information and the package license contains more than one controller the -c option shall be used to specify the controller.
-m

Specification of a single module or an individual list of modules that shall be used for validation or generation purpose.

The format of the list ist <ModuleName>[,<ModuleName] .

<ModuleName> could be the Module Short-Name e.g. WdgIf or the Module Definition Reference e.g. /MICROSAR/WdgIf.
-cc | Specification of the configuration phase for the generation process (PreCompile, Link, PostBuild)
-a

Transform the specified file (-f) with the specified AUTOSAR revision number in format 'Major.Minor.Patch' and save file with '~cfg4_' prefix.

A list of all supported namespace versions can be found in './__Engine/AS' installation folder .

Use -o to specify the new file name.
-log

A log file with all generation information will be created in any case.

Requires option -g.
-nobak

The backup of previously generated output files will be skipped in any case.

Requires option -g.
-noxsd

The AUTOSAR XSD schema validation will be skipped in any case.

Requires option -v or -g.
-sip

Specification of the package license folder that should be used for opening the project file (-f).

The use of -sip will ignore any registry key or project settings.
-f

Specification of project file that contains the configuration:

  • AUTOSAR ECUC file (*.arxml, *.xml)
  • DaVinci Configurator file (*.vixml)
  • DaVinci Project Assistant file (*.dpa)
-save

The project file (-f) will be saved at the end.

Use of -remPreCfg recommended to save the purged configuration.
-o

Specification of the full file name of the transformed ECU Configuration.

Requires option -a.
-full

Extend message line with additional information for further processing.

All context information as far as available will be printed as additional lines in the format
- $Object$ /Package/ModuleConfigurationInstanzName/.../ContainerInstanzName[/Parameter]
- $Definition$ /DefinitionPackage/ModuleShortName/.../ContainerDefinitionShortName[/Parameter]

If no configuration related parameter object is affected no additional lines will be printed.

Return Codes

The MicrosarGen.exe is returning following exit codes to the command shell in order to provide the result of the processed steps. The return code can be used to decide which additional steps in a batch file shall be executed, e.g. using the generated header files in a compiler run.

ErrorLevel(Value) | Description
EXITCODE_SUCCESS (0) | The process step was successful - no error(s) occurred.
EXITCODE_ERR_VALIDATE (1) | Some error(s) occurred during the validation process.
EXITCODE_ERR_GENERATE (2) | Some error(s) occurred during the generation process.
EXITCODE_ERROR (3) | Any other error(s) occurred.

How to use MicrosarGen.exe in a Make-Environment

Use sample batch file start.bat to call MicrosarGen.exe within a Make-Environment 'start.bat projectfilename'.
Following variables have to be set in the Make-Environment:

  • MICROSAR_DIR
    Installation-Directory of MicrosarGen.exe
  • MICROSAR_FLAGS
    All defined Parameters e.g. -h -s
Example

Example

####################################

## Setting common paths for tools

####################################

EXPORT MICROSAR_DIR=C:\MyInstallation

EXPORT MICROSAR_FLAGS=-g

#some other important code

####################################

## Generate Cfg of Sample_Project

####################################

$(MICROSAR_DIR)\start.bat $(MICROSAR_DIR)\MySampleProject.arxml

| AUTOSAR Modules |


Command Line Options

User Manual » Configurator » Features » Command Line Options

Description

You can use Command Line Options to specify a package license folder and a project.

How to use

DaVinciCFG.exe is run from a Windows command line interface ('DOS shell') by typing 'DaVinciCFG.exe [parameters]'. It can also be used as part of a batch file. Valid command line parameters are listed below.

Parameters

The following parameters are recognized by DaVinciCFG.exe as valid command line parameters.

DaVinciCFG.exe [-f ProjectFile|EcuConfig] [-sip PackageLicenseFolder]
Option | Description
-f | MICROSAR project (*.xml) or AUTOSAR ECUC description file (*.arxml)
-sip | set package license folder (should be used in combination with -f)


Vector Informatik GmbH - Addresses

Germany and all countries not listed below

USA, Canada, Mexico

Vector Informatik GmbH
Ingersheimer Str. 24
70499 Stuttgart
GERMANY
Phone: +49.711.80670.0
Fax: +49.711.80670.111
info@vector-informatik.de
http://www.vector-informatik.com

Vector CANtech, Inc.
Suite 550
39500 Orchard Hill Place
Novi, Mi 48375
USA
Phone: +1.248.449.9290
Fax: +1.248.449.9704
info@vector-cantech.com
http://www.vector-cantech.com

Sweden, Denmark, Norway, Finland, Iceland

France, Belgium, Luxemburg

VecScan AB
Theres Svenssons Gata 9
417 55 Göteborg
SWEDEN
Phone: +46.31.764.7600
Fax: +46.31.764.7619
info@vecscan.com
http://www.vecscan.com

Vector France SAS
168, Boulevard Camélinat
92240 Malakoff
FRANCE
Phone: +33.1.4231.4000
Fax: +33.1.4231.4009
information@vector-france.com
http://www.vector-france.com

Japan

Korea

Vector Japan Co., Ltd.
Seafort Square Center Bld. 18F
2-3-12 Higashi-shinagawa,
Shinagawa-ku
140-0002 Tokyo
JAPAN
Phone: +81.3.5769.7800
Fax: +81.3.5769.6975
info@vector-japan.co.jp
http://www.vector-japan.co.jp

Vector Korea IT Inc.
Daerung Post Tower III, 508
182-4 Guro-dong, Guro-gu
Seoul, 152-790
KOREA
Phone: +82.2.2028.0600
Fax: +82.2.2028.0604
info@vector-korea.com
http://www.vector-korea.com


Parameter Context Menu

User Manual » Configurator » Features » Parameter Context

Description

A context menu offers a limited set of choices that are available in the current state of the selected configuration parameter (<Shift> + <F1>).

Key | Menu Item | Description
Ctrl+C | Copy | Copy parameter value to Windows clipboard
Ctrl+V | Paste | Replace current parameter value with clipboard text
F6 | Edit Values | Open dialog to modify list of parameter values or select value
 | Set to Default Value | Replace current parameter value with the default value according to its definition. If the current value is already set to the default value, the menu item is marked up.
 | Set to Recommended Value | Replace current parameter value with the recommended value according to its definition. If the current value is already set to the recommended value, the menu item is marked up.
 | Set Display Format -> | Display current parameter value in Hex or Dec format (negative value will be ignored). The display format will be stored as User setting for all parameter of same definition context.
 | Remove Value | Remove value from configuration at all.
F10 | Comment... | Add or modify comment for current parameter. A comment can also be assigned if the parameter value is locked by any reason (Pre-configured value, project phase lock, ...). A parameter can have no or one comment, the text will be stored in ECUC in Admin Data node of the Container node (Only for parameters with a related AUTOSAR definition)
Shift+F1 | Parameter Help... | Display detail information of the parameter definition e.g. its short name, description, type, origin, derivation, definition reference, context and name of definition files
 | Copy -> | Copy selected value raised from its definition to Windows clipboard (ShortName, Definition Reference)